import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
  },
  onLoad() {
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })

  },
  // 保存信息
  saveInfo() {
    dd.navigateBack({
      delta: 1
    })

  },
  // 添加参会人
  addParticipants() {
    const _that = this
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      limitTips: "超出了",          //超过限定人数返回提示
      maxUsers: 1000,            //最大可选人数
      pickedUsers: _that.store.data.participatorUserId,            //已选用户
      requiredUsers: [],            //必选用户（不可取消选中状态
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        res.users.forEach((item, index) => {
          _that.store.data.participatorList.push({ userId: item.userId, username: item.name, headUrl: item.headUrl })
          _that.store.data.participatorUserId.push(item.userId)

        })
        _that.store.data.participatorList = _that.setArrary(_that.store.data.participatorList)
        _that.store.data.participatorUserId = [...new Set(_that.store.data.participatorUserId)]
        _that.update()
        dd.setNavigationBar({
          title: `参会人(${_that.store.data.participatorList.length}人）`
        })
      },
      fail: function (err) {
      }
    })
  },
  // 删除参会人
  delParticipants(event) {
    let userId = event.target.dataset.userId
    this.store.data.participatorList.forEach((item, index) => {
      if (userId === item.userId) {
        this.store.data.participatorList.splice(index, 1)
        this.update()
        return
      }
    })
    this.store.data.participatorUserId.forEach((item, index) => {
      if (userId === item) {
        this.store.data.participatorUserId.splice(index, 1)
        this.update()
        return
      }
    })
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })

  },
  // 数组去重
  setArrary(arr, userId) {
    console.log(arr)
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
});
